#ifndef EFL_GENERATED_ECORE_AUDIO_OUT_HH
#define EFL_GENERATED_ECORE_AUDIO_OUT_HH

extern "C"
{
#include <Efl.h>
}
#include <Eo.hh>

#include <eo_cxx_interop.hh>

extern "C"
{
#include "ecore_audio_out.eo.h"
}

#include "ecore_audio.eo.hh"
#include <eo_concrete.hh>

struct ecore_audio_out;

namespace eo_cxx {

struct ecore_audio_out
{
   /// @brief Attach an input to an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   bool input_attach(::efl::eina::optional< ::efl::eo::concrete > input_) const;


   /// @brief Detach an input from an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   bool input_detach(::efl::eina::optional< ::efl::eo::concrete > input_) const;


   /// @brief Returns the list of all attached inputs
   ///
   /// @since 1.8
   ///
   ::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > inputs_get() const;



   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OUT_CLASS);
   }

   operator ::ecore_audio_out() const;
   operator ::ecore_audio_out&();
   operator ::ecore_audio_out const&() const;

   template <typename D>
   struct address_of
   {
      operator ::ecore_audio_out*() const { return static_cast<::ecore_audio_out*>(static_cast<D const*>(this)->p); }
      operator ::ecore_audio_out const*() const { return static_cast<::ecore_audio_out const*>(static_cast<D const*>(this)->p); }
   };

   template <typename D>
   struct address_const_of
   {
      operator ::ecore_audio_out const*() const { return static_cast<::ecore_audio_out const*>(static_cast<D const*>(this)->p); }
   };

private:
   Eo* _concrete_eo_ptr() const
   {
      return static_cast<::efl::eo::concrete const*>(static_cast<void const*>(this))->_eo_ptr();
   }

};

}

struct ecore_audio_out
      : ::efl::eo::concrete
      , ::eo_cxx::ecore_audio
      , ::eo_cxx::eo::base
{
   ecore_audio_out(::efl::eo::parent_type _p = (::efl::eo::parent = nullptr))
      : ecore_audio_out(_ctors_call(_p))
   {}

   /// @brief Eo Constructor.
   ///
   /// Constructs the object from an Eo* pointer stealing its ownership.
   ///
   /// @param eo The Eo object pointer.
   ///
   explicit ecore_audio_out(Eo* eo)
      : ::efl::eo::concrete(eo)
   {}

   /// @brief nullptr_t Constructor.
   ///
   /// Constructs an empty (null) object.
   ///
   explicit ecore_audio_out(std::nullptr_t)
      : ::efl::eo::concrete(nullptr)
   {}

   /// @brief Copy Constructor.
   ///
   ecore_audio_out(ecore_audio_out const& other)
      : ecore_audio_out(eo_ref(other._eo_ptr()))
   {}

   ~ecore_audio_out() {}

   /// @brief Attach an input to an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   bool input_attach(::efl::eina::optional< ::efl::eo::concrete > input_) const;


   /// @brief Detach an input from an output
   ///
   /// @since 1.8
   ///
   /// @param input 
   ///
   bool input_detach(::efl::eina::optional< ::efl::eo::concrete > input_) const;


   /// @brief Returns the list of all attached inputs
   ///
   /// @since 1.8
   ///
   ::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > inputs_get() const;



   static Eo_Class const* _eo_class()
   {
      return(ECORE_AUDIO_OUT_CLASS);
   }

   struct address_of
      : ::eo_cxx::ecore_audio_out::address_of<address_of>
      , ::eo_cxx::ecore_audio::address_of<address_of>
      , ::eo_cxx::eo::base::address_of<address_of>
      , ::efl::eo::detail::concrete_address_of
   {
      explicit address_of(::ecore_audio_out* p)
         : ::efl::eo::detail::concrete_address_of(p)
      {}
   };
   address_of operator&() { return address_of(this); }

   struct address_const_of
      : ::eo_cxx::ecore_audio_out::address_const_of<address_const_of>
      , ::eo_cxx::ecore_audio::address_const_of<address_const_of>
      , ::eo_cxx::eo::base::address_const_of<address_const_of>
      , ::efl::eo::detail::concrete_address_const_of
   {
      explicit address_const_of(::ecore_audio_out const* p)
         : ::efl::eo::detail::concrete_address_const_of(p)
      {}
   };
   address_const_of operator&() const { return address_const_of(this); }

private:
   static Eo* _ctors_call(::efl::eo::parent_type _p)
   {
      Eo* _ret_eo = eo_add_ref(ECORE_AUDIO_OUT_CLASS, _p._eo_raw, );

      return _ret_eo;
   }

      Eo* _concrete_eo_ptr() const { return _eo_ptr(); }
};

static_assert(sizeof(::ecore_audio_out) == sizeof(Eo*), "");
static_assert(std::is_standard_layout<::ecore_audio_out>::value, "");

inline bool ecore_audio_out::input_attach(::efl::eina::optional< ::efl::eo::concrete > input_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_attach(::efl::eolian::to_c(input_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline bool ecore_audio_out::input_detach(::efl::eina::optional< ::efl::eo::concrete > input_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_detach(::efl::eolian::to_c(input_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline ::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > ecore_audio_out::inputs_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_inputs_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}


inline bool eo_cxx::ecore_audio_out::input_attach(::efl::eina::optional< ::efl::eo::concrete > input_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_attach(::efl::eolian::to_c(input_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline bool eo_cxx::ecore_audio_out::input_detach(::efl::eina::optional< ::efl::eo::concrete > input_) const
{
   Eina_Bool _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_input_detach(::efl::eolian::to_c(input_)));
   return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
}


inline ::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > eo_cxx::ecore_audio_out::inputs_get() const
{
   Eina_List * _tmp_ret;
   eo_do(_concrete_eo_ptr(), _tmp_ret = ::ecore_audio_obj_out_inputs_get());
   return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
}


inline ::eo_cxx::ecore_audio_out::operator ::ecore_audio_out() const
{
   return *static_cast<::ecore_audio_out const*>(static_cast<void const*>(this));
}

inline ::eo_cxx::ecore_audio_out::operator ::ecore_audio_out&()
{
   return *static_cast<::ecore_audio_out*>(static_cast<void*>(this));
}

inline ::eo_cxx::ecore_audio_out::operator ::ecore_audio_out const&() const
{
   return *static_cast<::ecore_audio_out const*>(static_cast<void const*>(this));
}

template <typename T>
bool _ecore_audio_out_input_attach_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eo * input_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->input_attach(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eo::concrete >>(input_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
bool _ecore_audio_out_input_detach_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self, Eo * input_)
{
   bool _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->input_detach(::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eo::concrete >>(input_, std::tuple<std::false_type>()));
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

template <typename T>
::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > _ecore_audio_out_inputs_get_wrapper(Eo* objid EINA_UNUSED, ::efl::eo::detail::Inherit_Private_Data* self)
{
   ::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > _tmp_ret{};
   try
      {
         _tmp_ret = static_cast<T*>(self->this_)->inputs_get();
      }
   catch (...)
      {
         eina_error_set( ::efl::eina::unknown_error() );
      }
   return _tmp_ret;
}

namespace efl { namespace eo { namespace detail {

template<>
struct operations< ::ecore_audio_out >
{
   template <typename T>
   struct type
         : virtual operations< ::ecore_audio >::template type<T>
   {
      virtual bool input_attach(::efl::eina::optional< ::efl::eo::concrete > input_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_out_input_attach(::efl::eolian::to_c(input_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual bool input_detach(::efl::eina::optional< ::efl::eo::concrete > input_)
      {
         Eina_Bool _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_out_input_detach(::efl::eolian::to_c(input_)));
            return ::efl::eolian::to_cxx<bool>(_tmp_ret, std::tuple<std::false_type>());
      }

      virtual ::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > > inputs_get()
      {
         Eina_List * _tmp_ret = {};

         eo_do_super(dynamic_cast<T*>(this)->_eo_ptr(),
               dynamic_cast<T*>(this)->_eo_class(),
               _tmp_ret = ::ecore_audio_obj_out_inputs_get());
            return ::efl::eolian::to_cxx<::efl::eina::optional< ::efl::eina::range_list< ::efl::eo::concrete > >>(_tmp_ret, std::tuple<std::false_type, std::false_type>());
      }

   };
};


template<>
struct operation_description_class_size< ::ecore_audio_out >
{
   static const int value = 3 + operation_description_class_size<::ecore_audio >::value;
};

template <typename T>
int initialize_operation_description(::efl::eo::detail::tag<::ecore_audio_out>
                                 , Eo_Op_Description* ops)
{
   (void)ops;
   ops[0].func = reinterpret_cast<void*>(& ::_ecore_audio_out_input_attach_wrapper<T>);
   ops[0].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_input_attach);
   ops[0].op = EO_OP_OVERRIDE;
   ops[0].op_type = EO_OP_TYPE_REGULAR;
   ops[0].doc = NULL;

   ops[1].func = reinterpret_cast<void*>(& ::_ecore_audio_out_input_detach_wrapper<T>);
   ops[1].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_input_detach);
   ops[1].op = EO_OP_OVERRIDE;
   ops[1].op_type = EO_OP_TYPE_REGULAR;
   ops[1].doc = NULL;

   ops[2].func = reinterpret_cast<void*>(& ::_ecore_audio_out_inputs_get_wrapper<T>);
   ops[2].api_func = reinterpret_cast<void*>(& ::ecore_audio_obj_out_inputs_get);
   ops[2].op = EO_OP_OVERRIDE;
   ops[2].op_type = EO_OP_TYPE_REGULAR;
   ops[2].doc = NULL;

   initialize_operation_description<T>(::efl::eo::detail::tag<::ecore_audio>(), &ops[3]);
   return 0;
}
inline void
call_constructor(::efl::eo::detail::tag< ::ecore_audio_out >
               , Eo* eo, Eo_Class const* cls EINA_UNUSED,
               ::efl::eo::detail::args_class<::ecore_audio_out, ::std::tuple<::efl::eo::parent_type> > const& args)
{
   eo_do(eo, ::eo_parent_set(args.get<0>()._eo_raw));
}

inline Eo_Class const* get_eo_class(tag<::ecore_audio_out>)
{
   return (ECORE_AUDIO_OUT_CLASS);
}

} } }
#endif // EFL_GENERATED_ECORE_AUDIO_OUT_HH

